      INTEGER FUNCTION SPAWN11(PROG, NPROC, TIDS, SPEEDS, NUM)
      INCLUDE 'fpvm3.h'
      INTEGER TIDS(*), SPEEDS(*), NPROC, NUM
      CHARACTER*128 PROG
C
C Spawn NPROC processes. These processes are as uniformly distributed
C as possible in the virtual machine.
C
C . NUM returns # of processes successfully spawned.
C   it should equal NPROC when no error encountered.
C
C . The name of the executable file is given by PROG, THE STRING MUST
C   BE ENDED BY ONE OR MORE BLANK CHARACTERS.
C
C . The SPEEDs and TIDs of successfully spawned processes are returned
C   respectively in the arrays TIDS and SPEEDS, the length of the arrays
C   should be greater than or equal to NPROC.
C
C . The return value of the function is the SPEED of the calling process
C
      CHARACTER*128 ARCH,NAME
      INTEGER NHOSTS,NARCH,DTID,SPEED, MYTID, MYDTID, MYSPEED, TID
C
      SPAWN11=0
      MYSPEED=0
      NUM=0
      CALL PVMFMYTID(MYTID)
C
C !!! The next instruction depends on the internal representation of TID
****      MYDTID=2**16*(MYTID/(2**16))
C Use PVMFTIDTOHOST instead, which is independent of the definition of TID
      CALL PVMFTIDTOHOST(MYTID,MYDTID)
C
C Compute the length of the program name and store it in I0
      I0=1
10    I0=I0+1
      IF (PROG(I0:I0).NE.' ') GOTO 10
      I0=I0-1
C
C Loop on NUM (current # of tasks spawned), and spawn tasks host by host.
100   CONTINUE
      CALL PVMFCONFIG(NHOSTS,NARCH,DTID,NAME,ARCH,SPEED,INFO)
      IF (INFO.LT.0) RETURN
      IF (MYSPEED.EQ.0) THEN
C Check if this host is myself and skip it for the first time.
         IF (DTID.EQ.MYDTID) THEN
            MYSPEED=SPEED
            IF (NUM.LT.NPROC) GOTO 100
         ENDIF
      ENDIF
      IF (NUM.LT.NPROC) THEN
         K=1
20       K=K+1
         IF (NAME(K:K).NE.' ') GOTO 20
         K=K-1
         CALL PVMFSPAWN(PROG(1:I0),PVMHOST,NAME(1:K),1,TID,INFO)
         IF (INFO.LE.0) RETURN
         NUM=NUM+1
         TIDS(NUM)=TID
         SPEEDS(NUM)=SPEED
      ENDIF
      IF (NUM.LT.NPROC .OR. MYSPEED.EQ.0) GOTO 100
C
      SPAWN11=MYSPEED
      RETURN
      END
